stages:
  - build
  - deploy
variables:
  IMAGE_NAME: "hamzarehmanshaikh/hamops"
  IMAGE_TAG: "1.3"
  DEV_SERVER_IP: 13.50.251.28

build-image:
  stage: build
  image: docker:20.10.10

  services:
    - docker:20.10.10-dind
  before_script:
    - docker login -u $CI_DOCKER_USER -p $CI_DOCKER_PASSWORD 
  script:
    - echo "Building docker image"
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker images
    - docker push $IMAGE_NAME:$IMAGE_TAG

deploy-on-aws:
  stage: deploy
  image: docker:20.10.10
  services:
    - docker:20.10.10-dind
  before_script:
    - chmod 400 $SSH_PRIVATE_KEY
  script:
    - echo "Deploying in AWS..."
    - ssh -o StrictHostKeyChecking=no -i $SSH_PRIVATE_KEY ubuntu@$DEV_SERVER_IP "
        docker run -d -p 3000:80 --name hamops-app $IMAGE_NAME:$IMAGE_TAG"
